#pragma once
#include <string>
using namespace std;

class CCoord {
 public:
	string name, unit;

	CCoord(void);
	CCoord(char *nin, char *uin);
	CCoord(string *nin, string *uin);
	CCoord(string nin, string uin);

	CCoord Ask(const char *quest, int defflag=0, 
		   const CCoord& defval=CCoord());

	friend ostream& operator<< (ostream &s, CCoord C);
	string str(void) const;
	string ps_str(void) const;
	string fstr(void) const;
	inline bool defined(void) { return name!=""; };
	string load(string);

 	inline bool operator== (const CCoord& Co2) { 
		return (name==Co2.name) && (unit==Co2.unit); };
	inline bool operator!= (const CCoord& Co2) { return !(*this==Co2); };

 private:
	static const char *helptext;
};

inline string strg(const CCoord& C) { return C.str(); };

class CParam {
 public:
	CCoord Co;
	double val;

	inline CParam(void) { };
	inline CParam(CCoord Cin, double vin=0) { Co = Cin; val = vin; };
	inline CParam(string nin, string uin="", double vin=0) 
		{ Co = CCoord(nin, uin); val = vin; };
};

