#include <stdlib.h>
#include <ctype.h>
#include <math.h>

#include "expr.h"
#include "node.h"
#include "xax_yacc.h"
#include "mystd.h"
#include "myexception.h"

//! Interface to xax lexer and parser:
int user_xaxparse( const string &lin, NodePtr *A ); //!< implemented in xax.l
int xaxerror (char *s); //!< implemented in xax.y


//! The following interface is called from the main program:
void exec_expression( string expr )
{
    NodePtr A;
    user_xaxparse( expr, &A );
    A->input_type_check();
    cout << A->strg() << " = ";
    if( A->rtyp()==Node::RET_VALUE )
        cout << A->eval_val() << "\n";
    else
        cout << "! not value typed\n";
}

Range range_parse( string expr )
{
    NodePtr A;
    user_xaxparse( expr, &A );
    A->input_type_check();
    if( A->rtyp()!=Node::RET_RANGE )
        throw BadInput( "input not in range format" );
    return A->eval_range();
}
