#include <iostream>

#include <string>
#include <vector>
#include <algorithm>

// #include "myexception.h"
#include "workspace.h"
#include "cmd.h"
#include "asi.h"
#include "gar.h"
#include "file_io.h"

void NFileIO::register_commands()
{
    theCommands.add_one( Cmd( &load, "fl" ) );
}

//! Load data or curve file from disk.
/** Called from main menu.
    Hands the call down to a sub-routine 
    that knows about a specific file format.
    Subroutines are in files file_i_96, file_i01, ... 
*/
void NFileIO::load()
{
    string fnames = wask( "Load file(s)" ); // PROVIS, sask sobald glob besser
    vector<string> vflong; // unix names
    if( mystd::glob_file_list( fnames, "", "a01", &vflong )<=0 ) {
        throw BadInput( "files " + fnames + " not found" );
    }
    FILE *F_in;
    string fdir, fshort, fext;
    // cout << "DEBUG: size " << vflong.size() << "\n";
    for( uint i=0; i<vflong.size(); ++i ) {
        try{ 
            if( !(F_in = fopen(vflong[i].c_str(), "r")) ) {
                throw BadInput( "cannot open file " + vflong[i] );
            }
            cout << ".. loading file " << vflong[i] << "\n";
            mystd::fname_divide( vflong[i], &fdir, &fshort, &fext);
            
            if        ( fext=="a01" ) {
                load_01( F_in, vflong[i] );
            } else if ( fext=="i96" ) {
                load_96( F_in, vflong[i] );
            } else {
                throw BadInput( "unknown file extension [" + fext + "]" );
            }
            
            fclose( F_in );
        }
        catch(exception& e) {
            cout << "DEBUG: catched locally\n";
            cerr << e.what() << endl;
            if (F_in) fclose(F_in);
        }
    }
}
