// This is range.tpl.h, #include'd by range.h

class T_CLASS {
 public:
	int flag; // 1: infinite, 2: empty, 4: exclude_inf, 8: exclude_sup
	T_TYPE inf, sup;
	bool valid;

	T_CLASS(void);
	T_CLASS(int flagin);
	T_CLASS(T_TYPE infin, T_TYPE supin);
	T_CLASS(int flagin, T_TYPE infin, T_TYPE supin);
	T_CLASS(const class O_CLASS& In);
	T_CLASS(const string& text);
	~T_CLASS(void);

	bool test(void);

	bool infinite() const;
	bool empty() const;
	bool finite() const;

	bool contained(double val) const;
#ifdef _CLIMITS
	bool contained(int val) const;
#endif
	bool overlap(const T_CLASS& T2) const;
	double relval(int logflag, double v) const;

#ifdef _CRANGE
	void Round(int logflag, double relmargin, double digits);
#endif

	T_CLASS operator*(const T_CLASS& R); // Vereinigungsmenge
	T_CLASS operator*=(const T_CLASS& R);
	T_CLASS operator+(const T_TYPE); // shift
	T_CLASS operator+=(const T_TYPE); 
	T_CLASS operator-(const T_TYPE); 
	T_CLASS operator-=(const T_TYPE);

	T_CLASS Ask(const char* quest);
	T_CLASS Ask(const char* quest, const T_CLASS& Def);
	T_CLASS Ask(const char* quest, bool defflag, const T_CLASS& Def);
	string str(void) const;
	inline const char* c_str(void) const
		{ return str().c_str(); };
	friend ostream& operator<< (ostream &s, const T_CLASS& R);

 private:
	static const char* helptext;
};

inline string strg(const T_CLASS& R) { return R.str(); };





