
//! A curve file contains curves, just as a data file contains scans.

#define N_FIT_METRICS 3

class CCurve {
 public:
    vector<double> P;
    vector<double> z;
    double Quality[N_FIT_METRICS];
    
    void Clear( void );
};


//! NCurFil holds operations on curve files

namespace NCurveFile {
    void setFunction( void *f, const string& expr );

    void Create( const string& cmd );
    void SetFileReference( const string& which );
    void SetConvTuningPars( string which );

    void SetProperties( string which );
    void ShowPar();
    void EditPar();
    void OprPar( string llabel );
    void SetFixed();

    void SetFitTuningPars( string which );
    void Fit( bool _allow_slow_conv );

    void SetIntTuningPars( string which );
    void IntegralProperty();

    void CumulativeDistribution();
};
