#include <set>
// #include <algorithm>

class IndexList { // unsorted

	friend class IndexListIterator;

 private:
	vector<uint> V;

 public:
	// Constructors:
	inline IndexList(void) { }; // create empty vector
	inline IndexList(const uint val) { V.push_back(val); };
	inline IndexList(const uint v0, const uint vn) {
		for (uint v=v0; v<vn; ++v) V.push_back(v); };

	// Modify:
	IndexList append (const IndexList& Vec2);
	IndexList append (const uint val);

	IndexList clear(void);
	IndexList reverse(void);
	IndexList sort(void);

	IndexList complement(const IndexList Vec2, 
			     const uint v0, const uint vn);
	
	// from text (return true if string was valid):
	bool parse(const string s, const uint v0=0, const uint vn=0);

	// Info:
	inline uint size(void) const { return V.size(); };
	bool contains (const uint val) const;
	// inline uint operator[] (const uint i) const { return T[i]; };
	// int issorted(void) const;
	string str(void) const;
	inline const char* c_str(void) const { return str().c_str(); } ;
};

class IndexSet { // sorted

	friend class IndexSetIterator;

 private:
	set<uint> T;

 public:
	// Constructors:
	inline IndexSet(void) { }; // create empty vector
	inline IndexSet(const uint val) { T.insert(val); };
	inline IndexSet(const uint v0, const uint vn) {
		for (uint v=v0; v<vn; ++v) T.insert(v); };

	// Modify:
	IndexSet insert (const IndexSet Set2);
	IndexSet insert (const uint val);

	IndexSet clear(void);

	IndexSet complement(const IndexSet Set2, 
			     const uint v0, const uint vn);
	
	// from text (returns 0 if string is valid):
	bool parse(const string s, const uint v0=0, const uint vn=0);

	bool ask(const string quest, const string def, 
		     const uint v0=0, const uint vn=0);
	inline bool ask(const string quest, const IndexSet set,
		     const uint v0=0, const uint vn=0) {
		return ask(quest, set.str(), v0, vn); };

	// Info:
	inline uint size(void) const { return T.size(); };
	bool contains (const uint val) const;
	// int issorted(void) const;
	string str(void) const;
	inline const char* c_str(void) const { return str().c_str(); } ;
};

class IndexListIterator : private IndexList { 
 private:
	uint i;
 public:
	inline IndexListIterator(void) { i=0; };
	inline IndexListIterator(const IndexList List) { i=0; V=List.V; };
	inline void reset(void) { i=0; };
	inline void reset(const IndexList List) { i=0; V=List.V; };
	inline uint operator()(uint *val) {
		if (i>=size()) return 0;
		*val = V[i++];
		return i;
	};
};

class IndexSetIterator : private IndexSet { 
 private:
	set<uint>::iterator pos;
	uint i;
	int dir;
 public:
	inline IndexSetIterator(void) { reset(); };
	inline IndexSetIterator(const IndexSet Set) { reset(Set); };
	inline void reset(void) { pos=T.begin(); i=0; dir=+1; };
	inline void reset(const IndexSet Set) { T=Set.T; reset(); };
	inline void setback(void) { pos=T.end(); i=T.size(); dir=-1; };
	inline void setback(const IndexSet Set) { T=Set.T; setback(); };
	inline bool operator()(uint *val) {
		if (dir>0) {
			if (pos==T.end()) return 0;
			*val = *(pos++);
			return ++i;
		} else {
			if (pos==T.begin()) return 0;
			*val = *(--pos);
			return i--;
		}
	};
	inline void stepback(void) {
		if (dir>0) --pos;
		else       ++pos;
	};
};

class IndexSelection {
 private:
	string S;
	
 public:
	void ask();
	
};

string index_ask(const string& quest, string def="", uint p0=0, uint pn=0);
